﻿Imports Microsoft.VisualBasic.ApplicationServices

' JunkPad 2.2.3 is very different to most text editors, let alone normal VB.net programs.
' DO NOT DELETE ANY OF THE EXIT SUBS. THESE ARE NECESSARY TO KEEP THE IF STATEMENTS WORKING PROPERLY.

Public Class frmMain

    Public openedfile As String
    Dim inttabs As Integer
    Dim hiddentabs As Integer
    'the public sub [general procedure] is so we can run it from other forms like the open form.
    Public Sub countwords()
        Dim str As String
        str = CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).TextLength
        lblCharCount.Text = "Characters: " + str
        Try
            Dim i, l, words As Integer
            str = CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text
            str = LTrim(str) 'removes leading blank spaces
            str = RTrim(str) ' removes trailing blank spaces
            l = str.Length
            i = 0
            words = 0
            While (i < l)
                If str(i) = " " Then
                    words = words + 1
                    i = i + 1
                    While str(i) = " " ' removes continuous blank spaces
                        i = i + 1
                    End While
                Else
                    i = i + 1
                End If

            End While
            words = words + 1 ' adds the last word
            lblWords.Text = ("Words: " & words)
        Catch ex As Exception
        End Try
    End Sub

    Private Sub BindCombo()
        Dim objFontFamily As FontFamily
        Dim objFontCollection As System.Drawing.Text.FontCollection
        objFontCollection = New System.Drawing.Text.InstalledFontCollection()
        For Each objFontFamily In objFontCollection.Families
            comFont.Items.Add(objFontFamily.Name)
            comFont.SelectedItem = "Microsoft Sans Serif"
            comFontSize.SelectedItem = "8"
        Next
    End Sub


    Private Sub frmMain_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        Dim Response As MsgBoxResult
        If lblTabs.Text = 0 Then
            End
        End If
        Try
            If lblTabs.Text >= 2 Then
                Response = MsgBox("There are still " + lblTabs.Text + " tabs open! Save changes to them?", _
              MsgBoxStyle.Exclamation + MsgBoxStyle.YesNoCancel, _
              "JunkPad")
                If Response = MsgBoxResult.No Then
                    Exit Sub
                End If
                If Response = MsgBoxResult.Cancel Then
                    e.Cancel = True
                    Exit Sub
                End If
                If Response = MsgBoxResult.Yes Then
                    If openedfile = "" Then
                        e.Cancel = True
                        frmSave.lblFromSaveBtn.Text = 1
                        frmSave.ShowDialog()
                        Exit Sub
                    End If
                    e.Cancel = True
                    If openedfile.Contains(".dild") Or openedfile.Contains(".rtf") Then
                        frmSave.comboxEditor.SelectedItem = "Save as rich text file"
                        frmSave.lblFromSave1.Text = 1
                        frmSave.ShowDialog()
                    Else
                        frmSave.comboxEditor.SelectedItem = "Save as plain text file"
                        frmSave.lblFromSave1.Text = 1
                        frmSave.ShowDialog()
                    End If
                    Exit Sub
                End If
            End If
            'for 1 tab below
            If CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = True Then
                If lblTabs.Text = 1 Then
                    Response = MsgBox("Save changes to " + TabControl1.SelectedTab.Text + " ?", _
                                      MsgBoxStyle.Exclamation + MsgBoxStyle.YesNoCancel, _
                                      "JunkPad")
                End If
                If Response = MsgBoxResult.No Then
                    Exit Sub
                End If
                If Response = MsgBoxResult.Cancel Then
                    e.Cancel = True
                    Exit Sub
                End If
                If Response = MsgBoxResult.Yes Then
                    If openedfile = "" Then
                        e.Cancel = True
                        frmSave.lblFromSaveBtn.Text = 1
                        frmSave.ShowDialog()
                        Exit Sub
                    End If
                    e.Cancel = True
                    If openedfile.Contains(".dild") Or openedfile.Contains(".rtf") Then
                        frmSave.comboxEditor.SelectedItem = "Save as rich text file"
                        frmSave.lblFromSave1.Text = 1
                        frmSave.ShowDialog()
                    Else
                        frmSave.comboxEditor.SelectedItem = "Save as plain text file"
                        frmSave.lblFromSave1.Text = 1
                        frmSave.ShowDialog()
                    End If
                End If
            End If
        Catch ex As Exception
            End
        End Try
    End Sub


    Private Sub frmMain_KeyUp(sender As Object, e As KeyEventArgs) Handles Me.KeyUp
        If lblTabs.Text = 0 Then
            Exit Sub
        End If
        Try
            If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
                Exit Sub
            End If
            If CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = True Then
                If TabControl1.SelectedTab.ImageIndex = 1 Then
                    countwords() 'calls the count words general procedure
                    If CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text = "" Then
                        CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False
                        TabControl1.SelectedTab.ImageIndex = 0
                        Exit Sub
                    End If
                Else
                    TabControl1.SelectedTab.ImageIndex = 1
                    countwords() 'calls the count words general procedure
                End If
            End If
        Catch ex As Exception
        End Try
    End Sub
    Private Sub frmMain_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        BindCombo() 'this initiates the general procedure that loads all installed fonts for the combo-box.

        'below detects whether a file was opened using windows explorer. here, we'll load it into junkpad.
        If (My.Application.CommandLineArgs.Count = 0) Then 'if no commands are present, we'll add a new blank text tab.
            addtab()
        Else

            openedfile = My.Application.CommandLineArgs(0).ToString 'declares that there is a file loaded into the program
            If openedfile.Contains(".dild") Or openedfile.Contains(".rtf") Then 'if it contains the richtext extensions (either .dild or .rtf), then the following will happen, unless it's something else.
                addtab()
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).LoadFile(My.Application.CommandLineArgs(0)) 'loads it using the richtext loader
                TabControl1.SelectedTab.ImageIndex = 5
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False
            Else
                addtab()
                Dim myStreamReader As System.IO.StreamReader 'declares the loader as plaintext
                myStreamReader = System.IO.File.OpenText(My.Application.CommandLineArgs(0))
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text = myStreamReader.ReadToEnd()
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False
                TabControl1.SelectedTab.ImageIndex = 5
            End If
            ' if there was an 'Exit Sub' above the 'End If', the following wouldn't run, because we're exiting the sub (stopping it from executing more code). 
            TabControl1.SelectedTab.Text = My.Application.CommandLineArgs(0).ToString
            Me.Text = "JunkPad II - " + TabControl1.SelectedTab.Text
            countwords()
        End If
    End Sub

    Private Sub btnRename_Click(sender As Object, e As EventArgs) Handles btnRename.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("Renaming functions are not available with all tabs closed.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            frmQuickTabs.txtBoxName.Enabled = False
            frmQuickTabs.chkDisableWordWrap.Enabled = False
            frmQuickTabs.ShowDialog()
        End If
        If lblTabs.Text >= 0 Then
            frmQuickTabs.txtBoxName.Enabled = True
            frmQuickTabs.chkDisableWordWrap.Enabled = True
            frmQuickTabs.ShowDialog()
        End If
    End Sub

    Private Sub TabControl1_DoubleClick(sender As Object, e As EventArgs)
        Try
            CType(frmQuickTabs.Controls.Item("txtBoxName"), TextBox).Text = TabControl1.SelectedTab.Text
            frmQuickTabs.ShowDialog()
            TabControl1.SelectedTab.Text = CType(frmQuickTabs.Controls.Item("txtBoxName"), TextBox).Text
            Me.Text = "JunkPad II - " + TabControl1.SelectedTab.Text
        Catch Ex As Exception
            MessageBox.Show("No tabs to rename.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try
    End Sub

    Private Sub OpenToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles OpenToolStripMenuItem.Click
        If lblTabs.Text = 256 Then
            MessageBox.Show("You have reached the maximux allowed tabs that can be created.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Hand)
            Exit Sub
        Else
            If lblTabs.Text = 0 Then
                frmOpen.comboxEditor.Enabled = False
            Else
                frmOpen.comboxEditor.Enabled = True
            End If
            frmOpen.ShowDialog()
        End If
    End Sub

    Private Sub btnUndo_Click(sender As Object, e As EventArgs) Handles btnUndo.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to Undo in.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Undo()
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = True
            TabControl1.SelectedTab.ImageIndex = 1
            Exit Sub
        End If
    End Sub

    Private Sub btnRedo_Click(sender As Object, e As EventArgs) Handles btnRedo.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to Redo in.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Redo()
            Exit Sub
        End If
    End Sub

    Private Sub btnCloneTab_Click(sender As Object, e As EventArgs) Handles btnCloneTab.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to duplicate.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If lblTabs.Text = 256 Then
            MessageBox.Show("You have reached the maximux allowed tabs that can be created.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Hand)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
            INTdupetab()
        Else
            dupetab()
        End If
    End Sub
    Public Sub dupetab()
        Dim oldname As String
        oldname = TabControl1.SelectedTab.Text
        Try
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectAll()
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Copy()
            If CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectedText = "" Then
                Dim Response As MsgBoxResult
                Response = MsgBox("Your selected tab has no text in it. Would you like to paste content from the clipboard?", _
                                      MsgBoxStyle.Information + MsgBoxStyle.YesNo, _
                                      "JunkPad II")
                If Response = MsgBoxResult.No Then
                    Dim richtext As New RichTextBox
                    Dim edittab As New TabPage
                    edittab.Controls.Add(richtext)
                    richtext.Dock = DockStyle.Fill
                    richtext.BorderStyle = BorderStyle.None
                    richtext.ContextMenuStrip = cmsMain
                    TabControl1.TabPages.Add(edittab)
                    TabControl1.SelectTab(edittab)
                    TabControl1.SelectedTab.Text = oldname
                    lblTabs.Text = lblTabs.Text + 1
                    Me.Text = "JunkPad II - " + TabControl1.SelectedTab.Text
                    TabControl1.SelectedTab.ImageIndex = 4
                    CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False
                End If

                If Response = MsgBoxResult.Yes Then
                    Dim richtext As New RichTextBox
                    Dim edittab As New TabPage
                    edittab.Controls.Add(richtext)
                    richtext.Dock = DockStyle.Fill
                    richtext.BorderStyle = BorderStyle.None
                    richtext.ContextMenuStrip = cmsMain
                    TabControl1.TabPages.Add(edittab)
                    TabControl1.SelectTab(edittab)
                    TabControl1.SelectedTab.Text = oldname
                    lblTabs.Text = lblTabs.Text + 1
                    Text = "JunkPad II - " + TabControl1.SelectedTab.Text
                    TabControl1.SelectedTab.ImageIndex = 4
                    CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Paste()
                    CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False
                End If
                Exit Sub
            Else
                Dim richtext As New RichTextBox
                Dim edittab As New TabPage
                edittab.Controls.Add(richtext)
                richtext.Dock = DockStyle.Fill
                richtext.BorderStyle = BorderStyle.None
                richtext.ContextMenuStrip = cmsMain
                TabControl1.TabPages.Add(edittab)
                TabControl1.SelectTab(edittab)
                TabControl1.SelectedTab.Text = oldname
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Paste()
                lblTabs.Text = lblTabs.Text + 1
                Text = "JunkPad II - " + TabControl1.SelectedTab.Text
                TabControl1.SelectedTab.ImageIndex = 4
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False
            End If

        Catch ex As Exception
            MessageBox.Show("An error occured while duplicating the tab.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub
#Region "Append Text"
    Private Sub btnAppendText_Click(sender As Object, e As EventArgs) Handles btnAppendText.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("You can't append text to an non-existant tab!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        frmOpen.lblFromAppend.Text = 1
        frmOpen.ShowDialog()
    End Sub
#End Region
#Region "Custom Setup of tabs"
    Private Sub CustomSetupToolStripMenuItem_Click(sender As Object, e As EventArgs)
        frmQuickTabs.ShowDialog()
    End Sub
#End Region
#Region "Enable / disable 'Tab Limit Reached'"
    Private Sub lblTabs_TextChanged(sender As Object, e As EventArgs) Handles lblTabs.TextChanged
        If lblTabs.Text = 256 Then
            lblTabLimit.Visible = True
        End If
        If lblTabs.Text < 256 Then
            lblTabLimit.Visible = False
        End If
    End Sub
#End Region
#Region "Other shit"
    Private Sub NewToolStripMenuItem_Click(sender As Object, e As EventArgs)
        frmQuickTabs.ShowDialog()
    End Sub
#Region "Cut, Copy, Paste & Select All"
    Private Sub btnCut_Click(sender As Object, e As EventArgs) Handles btnCut.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to cut in.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Cut()
        End If
    End Sub

    Private Sub btnPaste_Click(sender As Object, e As EventArgs) Handles btnPaste.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to paste in.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Paste()
        End If
    End Sub

    Private Sub btnCopy_Click(sender As Object, e As EventArgs) Handles btnCopy.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to copy in.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Copy()
        End If
    End Sub

    Private Sub btnSelectAll_Click(sender As Object, e As EventArgs) Handles btnSelectAll.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to Select All text in.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectAll()
        End If
    End Sub
#End Region

    Private Sub ChangeWindowColourToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ChangeWindowColourToolStripMenuItem.Click
        dlgColour.ShowDialog()
        Me.BackColor = dlgColour.Color
        ToolStrip1.BackColor = dlgColour.Color
        ToolStrip2.BackColor = dlgColour.Color
        MenuStrip1.BackColor = dlgColour.Color
        StatusStrip1.BackColor = dlgColour.Color
    End Sub

    Private Sub ResetWindowColourToDefaultToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ResetWindowColourToDefaultToolStripMenuItem.Click
        Me.BackColor = DefaultBackColor
        ToolStrip1.BackColor = DefaultBackColor
        ToolStrip2.BackColor = DefaultBackColor
        MenuStrip1.BackColor = DefaultBackColor
        StatusStrip1.BackColor = DefaultBackColor
    End Sub

    Private Sub ChangeTextColourwindowToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ChangeTextColourwindowToolStripMenuItem.Click
        dlgColour.ShowDialog()
        lblTab.ForeColor = dlgColour.Color
        lblTabs.ForeColor = dlgColour.Color
        MenuStrip1.ForeColor = dlgColour.Color
        lblCharCount.ForeColor = dlgColour.Color
        lblWords.ForeColor = dlgColour.Color
    End Sub

    Private Sub ChangeTextfieldBackgroundToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ChangeTextfieldBackgroundToolStripMenuItem.Click
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            dlgColour.ShowDialog()
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).BackColor = dlgColour.Color
            Exit Sub
        End If
    End Sub

    Private Sub ExitToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ExitToolStripMenuItem.Click
        Dim Response As MsgBoxResult
        Response = MsgBox("Save your changes in all tabs. Have you done this? If you haven't, you will lose any unsaved data!", _
                              MsgBoxStyle.Exclamation + MsgBoxStyle.YesNo, _
                              "JunkPad II")
        If Response = MsgBoxResult.No Then
            Exit Sub
        End If

        If Response = MsgBoxResult.Yes Then
            End
        End If
    End Sub

    Private Sub HidePanelToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles HidePanelToolStripMenuItem.Click
        ToolStrip2.Visible = False
        ToolStrip1.Visible = False
        pnlTop.Height = 24
        HidePanelToolStripMenuItem.Enabled = False
        ShowPanelToolStripMenuItem.Enabled = True
    End Sub

    Private Sub ShowPanelToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ShowPanelToolStripMenuItem.Click
        ToolStrip2.Visible = True
        ToolStrip1.Visible = True
        pnlTop.Height = 74
        HidePanelToolStripMenuItem.Enabled = True
        ShowPanelToolStripMenuItem.Enabled = False
    End Sub

    Private Sub PreviewFileToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles PreviewFileToolStripMenuItem1.Click
        lblStatus.Visible = True
        comFont.Enabled = False
        comFontSize.Enabled = False
        preview_html()
    End Sub

    Private Sub LoadHTMLFileToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles LoadLocalFileToolStripMenuItem.Click
        comFont.Enabled = False
        comFontSize.Enabled = False
        loadhtml()
    End Sub

    Public Sub addtab()
        Try
            Dim richtext As New RichTextBox
            Dim edittab As New TabPage
            edittab.Controls.Add(richtext)
            richtext.Dock = DockStyle.Fill
            richtext.BorderStyle = BorderStyle.None
            richtext.ContextMenuStrip = cmsMain
            TabControl1.TabPages.Add(edittab)
            TabControl1.SelectTab(edittab)
            TabControl1.SelectedTab.Text = "unnamed"
            lblTabs.Text = lblTabs.Text + 1
            Me.Text = "JunkPad II - " + TabControl1.SelectedTab.Text
            lblCharCount.Text = "Characters: 0"
            lblWords.Text = "Words: 0"
            TabControl1.SelectedTab.ImageIndex = 0
            comFont.Enabled = True
            comFontSize.Enabled = True
        Catch ex As Exception
        End Try
    End Sub
#Region "Misc"
    Private Sub LeftToolStripMenuItem_Click(sender As Object, e As EventArgs)
        TabControl1.Alignment = TabAlignment.Left
        LeftToolStripMenuItem.Enabled = False
        RightToolStripMenuItem.Enabled = True
        TopdefaultToolStripMenuItem.Enabled = True
        BottomToolStripMenuItem.Enabled = True
    End Sub

    Private Sub TopdefaultToolStripMenuItem_Click(sender As Object, e As EventArgs)
        TabControl1.Alignment = TabAlignment.Top
        LeftToolStripMenuItem.Enabled = True
        RightToolStripMenuItem.Enabled = True
        TopdefaultToolStripMenuItem.Enabled = False
        BottomToolStripMenuItem.Enabled = True
    End Sub

    Private Sub RightToolStripMenuItem_Click(sender As Object, e As EventArgs)
        TabControl1.Alignment = TabAlignment.Right
        LeftToolStripMenuItem.Enabled = True
        RightToolStripMenuItem.Enabled = False
        TopdefaultToolStripMenuItem.Enabled = True
        BottomToolStripMenuItem.Enabled = True
    End Sub

    Private Sub BottomToolStripMenuItem_Click(sender As Object, e As EventArgs)
        TabControl1.Alignment = TabAlignment.Bottom
        LeftToolStripMenuItem.Enabled = True
        RightToolStripMenuItem.Enabled = True
        TopdefaultToolStripMenuItem.Enabled = True
        BottomToolStripMenuItem.Enabled = False
    End Sub

    Private Sub DisableWordWrapToolStripMenuItem_Click(sender As Object, e As EventArgs)
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to change WordWrap setting in.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If DisableWordWrapToolStripMenuItem.Checked = False Then
            DisableWordWrapToolStripMenuItem.Checked = True
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).WordWrap = False
            Exit Sub
        End If
        If DisableWordWrapToolStripMenuItem.Checked = True Then
            DisableWordWrapToolStripMenuItem.Checked = False
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).WordWrap = True
            Exit Sub
        End If
    End Sub
#End Region
    '////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    'TABCONTROL - SELECTED TAB
    Private Sub TabControl1_Selected(sender As Object, e As TabControlEventArgs)
        If lblTabs.Text = 0 Then
            MessageBox.Show("All tabs are closed.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        Try
            If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
                TabControl1.SelectedTab.Text = CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).DocumentTitle
                pnlDisplay.Visible = True
                btnSource.Visible = True
                comFont.Enabled = False
                comFontSize.Enabled = False
            Else
                pnlDisplay.Visible = False
                btnSource.Visible = False
                comFont.Enabled = True
                comFontSize.Enabled = True
                countwords()
            End If
            Me.Text = "JunkPad II - " & TabControl1.SelectedTab.Text

        Catch ex As Exception
        End Try
    End Sub

    Private Sub btnFindReplace_Click(sender As Object, e As EventArgs) Handles btnFindReplace.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to search text in.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        frmSearch.Show()
    End Sub

    Private Sub btnSaveAs_Click(sender As Object, e As EventArgs) Handles btnSaveAs.Click
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
            CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).ShowSaveAsDialog()
        Else
            Try
                If lblTabs.Text = 0 Then
                    MessageBox.Show("No tabs open to save in.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    Exit Sub
                End If
                If lblTabs.Text > 0 Then
                    If openedfile.Contains(Nothing) Then
                        frmSave.ShowDialog()
                        Exit Sub
                    End If
                    If openedfile.Contains(".dild") Or openedfile.Contains(".rtf") Then
                        frmSave.comboxEditor.SelectedItem = "Save as rich text file"
                    Else
                        frmSave.comboxEditor.SelectedItem = "Save as plain text file"
                    End If
                    frmSave.ShowDialog()
                End If
            Catch ex As Exception
                frmSave.ShowDialog()
            End Try
        End If
    End Sub
#End Region


    Private Sub btnLeftAlign_Click(sender As Object, e As EventArgs) Handles btnLeftAlign.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to change text alignment in.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionAlignment = HorizontalAlignment.Left
    End Sub

    Private Sub btnCenterAlign_Click(sender As Object, e As EventArgs) Handles btnCenterAlign.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to change text alignment in.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionAlignment = HorizontalAlignment.Center
    End Sub

    Private Sub btnRightAlign_Click(sender As Object, e As EventArgs) Handles btnRightAlign.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to change text alignment in.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionAlignment = HorizontalAlignment.Right
    End Sub

    Private Sub SaveToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SaveToolStripMenuItem.Click
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
            btnSaveAs_Click(Me, e)
        Else
            If lblTabs.Text = 0 Then
                MessageBox.Show("No tabs to save document in.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Exit Sub
            End If
            If openedfile = "" Then
                btnSaveAs_Click(Me, e)
                Exit Sub
            End If
            If openedfile.Contains(".dild") Or openedfile.Contains(".rtf") Then
                frmSave.comboxEditor.SelectedItem = "Save as rich text file"
                frmSave.lblFromSave1.Text = 1
                frmSave.ShowDialog()
            Else
                frmSave.comboxEditor.SelectedItem = "Save as plain text file"
                frmSave.lblFromSave1.Text = 1
                frmSave.ShowDialog()
            End If
        End If
    End Sub

    Private Sub RestartTheProgramToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles RestartTheProgramToolStripMenuItem.Click
        Application.Restart()
    End Sub

    Private Sub AboutJunkPadToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles AboutJunkPadToolStripMenuItem.Click
        frmAbout.lblDetail.Visible = True
        frmAbout.lblIconLegend.Visible = False
        frmAbout.picFile1.Visible = False
        frmAbout.picFile2.Visible = False
        frmAbout.picFile3.Visible = False
        frmAbout.picFile4.Visible = False
        frmAbout.picFile5.Visible = False
        frmAbout.ShowDialog()
    End Sub

    Private Sub IconLegendToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles IconLegendToolStripMenuItem.Click
        frmAbout.lblDetail.Visible = False
        frmAbout.lblIconLegend.Visible = True
        frmAbout.picFile1.Visible = True
        frmAbout.picFile2.Visible = True
        frmAbout.picFile3.Visible = True
        frmAbout.picFile4.Visible = True
        frmAbout.picFile5.Visible = True
        frmAbout.ShowDialog()
    End Sub

    Private Sub ImageToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ImageToolStripMenuItem.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("You can't insert an image to an non-existant tab!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
            MessageBox.Show("Inserting images is not available.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        Try
            Dim openFile1 As New OpenFileDialog()
            ' Initialize the OpenFileDialog to look for RTF files.
            openFile1.DefaultExt = "*.jpeg; *.jpg"
            openFile1.Filter = "Picture Files | *.jpg; *.png; *.gif; *.bmp |All files (*.*)|*.*"

            ' Determine whether the user selected a file from the OpenFileDialog. 
            If (openFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                And (openFile1.FileName.Length > 0) Then
                Dim img As Image = Image.FromFile(openFile1.FileName)
                Dim orgData = Clipboard.GetDataObject
                Clipboard.SetImage(img)
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Paste()
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = True
                TabControl1.SelectedTab.ImageIndex = 1
                Clipboard.SetDataObject(orgData)
            End If
        Catch ex As OutOfMemoryException
            MessageBox.Show("Invaild image selected.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Hand)
        Catch ex As Exception
            MessageBox.Show("An error occured while adding the image.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Hand)
        End Try
    End Sub

    Private Sub DateAndTimeToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles DateAndTimeToolStripMenuItem.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("You can't add the date to an non-existant tab!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
            MessageBox.Show("Inserting the date is not available.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectedText = DateAndTime.Now
        CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = True
        TabControl1.SelectedTab.ImageIndex = 1
    End Sub

    Private Sub FontSetup(sender As Object, e As EventArgs) Handles btnItalics.Click, btnBold.Click, btnUnderline.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to change font style in.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            btnBold.Checked = False
            btnItalics.Checked = False
            btnUnderline.Checked = False
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
            MessageBox.Show("Changing text style is not available.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            btnBold.Checked = False
            btnItalics.Checked = False
            btnUnderline.Checked = False
            Exit Sub
        End If
        Try
            If btnBold.Checked = True Then
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont = New Font(CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont, FontStyle.Bold)

                If btnItalics.Checked = True Then
                    CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont = New Font(CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont, FontStyle.Bold + FontStyle.Italic)
                    If btnUnderline.Checked = True Then
                        CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont = New Font(CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont, FontStyle.Bold + FontStyle.Underline + FontStyle.Italic)
                    Else
                        Exit Sub
                    End If
                Else
                    CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont = New Font(CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont, FontStyle.Bold)
                End If

                If btnUnderline.Checked = True Then
                    CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont = New Font(CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont, FontStyle.Bold + FontStyle.Underline)
                    If btnItalics.Checked = True Then
                        CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont = New Font(CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont, FontStyle.Bold + FontStyle.Underline + FontStyle.Italic)
                    Else
                        Exit Sub
                    End If
                Else
                    CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont = New Font(CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont, FontStyle.Bold)
                End If
                Exit Sub 'strangely enough, it works with this here, because for some reason, else statements are broken. This does the else statement for it. DO NOT DELETE IT. 
            Else
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont = New Font(CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont, FontStyle.Regular)
            End If

            If btnItalics.Checked = True Then
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont = New Font(CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont, FontStyle.Italic)
                If btnUnderline.Checked = True Then
                    CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont = New Font(CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont, FontStyle.Underline + FontStyle.Italic)
                End If
                Exit Sub
            Else
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont = New Font(CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont, FontStyle.Regular)
            End If

            If btnUnderline.Checked = True Then
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont = New Font(CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont, FontStyle.Underline)
                If btnItalics.Checked = True Then
                    CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont = New Font(CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont, FontStyle.Underline + FontStyle.Italic)
                End If
                Exit Sub
            Else
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont = New Font(CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont, FontStyle.Regular)
            End If
        Catch ex As Exception
        End Try
    End Sub

    Private Sub AppendToDocumentToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles AppendTextToolStripMenuItem.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to append text to.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
            MessageBox.Show("Appending text is not available.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        MessageBox.Show("That you can just press the icon (the little white box with the +) on the toolbar and it'll do the same thing?", "Did you know?", MessageBoxButtons.OK, MessageBoxIcon.Information)
        frmOpen.lblFromAppend.Text = 1
        frmOpen.ShowDialog()
    End Sub

    Private Sub comFont_SelectedIndexChanged(sender As Object, e As EventArgs) Handles comFont.SelectedIndexChanged
        Try
            If lblTabs.Text = 0 Then
                Exit Sub
            End If
            If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
                comFont.Enabled = False
            Else
                comFont.Enabled = True
            End If
            Dim ComboFonts As System.Drawing.Font
            ComboFonts = CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont = New Font(comFont.SelectedItem.ToString, CInt(comFontSize.SelectedItem.ToString), CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont.Style)
        Catch ex As Exception
        End Try
    End Sub

    Private Sub comFontSize_MouseUp(sender As Object, e As MouseEventArgs) Handles comFontSize.MouseUp
        Try
            If lblTabs.Text = 0 Then
                Exit Sub
            End If
            If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
                comFontSize.Enabled = False
            Else
                comFontSize.Enabled = True
            End If
            If e.Button = Windows.Forms.MouseButtons.Right Then
                Dim size As Integer
                size = InputBox("Enter the size you would like your font to be.", "Custom font size", "8")
                Dim ComboFonts As System.Drawing.Font
                ComboFonts = CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont = New Font(comFont.SelectedItem.ToString, size, CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont.Style)
            End If
        Catch ex As Exception
        End Try
    End Sub

    Private Sub comFontSize_SelectedIndexChanged(sender As Object, e As EventArgs) Handles comFontSize.SelectedIndexChanged
        Try
            If lblTabs.Text = 0 Then
                Exit Sub
            End If
            If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
                comFontSize.Enabled = False
            Else
                comFontSize.Enabled = True
            End If
            Dim ComboFonts As System.Drawing.Font
            ComboFonts = CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont = New Font(comFont.SelectedItem.ToString, CInt(comFontSize.SelectedItem.ToString), CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont.Style)
        Catch ex As Exception
        End Try
    End Sub

    Private Sub btnFontColor_Click(sender As Object, e As EventArgs) Handles btnFontColor.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("You can't change the font colour in an non-existant tab!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
            MessageBox.Show("Changing font colour is not available.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        dlgColour.Color = CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionColor
        dlgColour.ShowDialog()
        If Windows.Forms.DialogResult.Cancel = True Then
            Exit Sub
        End If
        If Windows.Forms.DialogResult.OK = True Then
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionColor = dlgColour.Color
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = True
            TabControl1.SelectedTab.ImageIndex = 1
        End If
        CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionColor = dlgColour.Color
    End Sub

    Private Sub preview_html()
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to preview HTML content in.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            Dim path As String = System.Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments)
            Dim FILE_NAME As String = path & "\preview.html"
            If System.IO.File.Exists(FILE_NAME) = False Then
                System.IO.File.Create(FILE_NAME).Dispose()
            End If
            Dim objWriter As New System.IO.StreamWriter(FILE_NAME, False)
            objWriter.Write(CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text)
            objWriter.Close()
            If lblTabs.Text = 256 Then
                MessageBox.Show("You have reached the maximux allowed tabs that can be created. Previewing HTML file cancelled!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Hand)
                Exit Sub
            Else
                Dim richtext As New WebBrowser
                Dim edittab As New TabPage
                edittab.Controls.Add(richtext)
                richtext.Dock = DockStyle.Fill
                TabControl1.TabPages.Add(edittab)
                TabControl1.SelectTab(edittab)
                TabControl1.SelectedTab.Text = "preview.html"
                lblTabs.Text = lblTabs.Text + 1
                txtURL.Text = path & "\preview.html"
                CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).ScriptErrorsSuppressed = True
                CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).Navigate("file:///" & path & "\preview.html")
                Me.Text = "JunkPad II - " + TabControl1.SelectedTab.Text
                TabControl1.SelectedTab.ImageIndex = 6
            End If
            lblStatus.Visible = False
        End If
    End Sub

    Private Sub btnBullets_Click(sender As Object, e As EventArgs) Handles btnBullets.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to add bullet points to.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
            MessageBox.Show("Adding bullet points is not available.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If btnBullets.Checked = True Then
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).BulletIndent = 10
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionBullet = True
        Else
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).BulletIndent = 0
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionBullet = False
        End If
    End Sub

    Private Sub btnBullets_MouseUp(sender As Object, e As MouseEventArgs) Handles btnBullets.MouseUp
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to add bullet points to.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
            MessageBox.Show("Adding bullet points is not available.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If e.Button = Windows.Forms.MouseButtons.Right Then
            Try
                Dim size As Integer
                size = InputBox("Enter the indent size of the bullet points (the distance from the bullet to the text).", "Custom bullet indent size", "10")
                btnBullets.Checked = True
                If size >= 200 Then
                    MessageBox.Show("You might need to turn off WordWrap in order to see the text.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
                End If
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).BulletIndent = size
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionBullet = True
            Catch ex As Exception
            End Try
        End If
    End Sub

    Private Sub btnIndent_Click(sender As Object, e As EventArgs) Handles btnIndent.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to add the indent points to.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
            MessageBox.Show("Adding the indent is not available.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If btnIndent.Checked = True Then
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionIndent = 10
        Else
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionIndent = 0
        End If
    End Sub

    Private Sub btnIndent_MouseUp(sender As Object, e As MouseEventArgs) Handles btnIndent.MouseUp
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to add the indent points to.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
            MessageBox.Show("Adding the indent is not available.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If e.Button = Windows.Forms.MouseButtons.Right Then
            Try
                Dim size As Integer
                size = InputBox("Enter the indent size of the text.", "Custom indent size", "10")
                btnIndent.Checked = True
                If size >= 200 Then
                    MessageBox.Show("You might need to turn off WordWrap in order to see the text.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
                End If
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionIndent = size
            Catch ex As Exception
            End Try
        End If
    End Sub

    Private Sub PrintToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles PrintToolStripMenuItem.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to print documents from.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
            CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).ShowPrintDialog()
            Exit Sub
        End If
        frmPrint.rtbDoc.Rtf = CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Rtf
        frmPrint.ShowDialog()
    End Sub

    Private Sub btnHighLight_MouseUp(sender As Object, e As MouseEventArgs) Handles btnHighLight.MouseUp
        If lblTabs.Text = 0 Then
            MessageBox.Show("You can't highlight text in an non-existant tab!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
            MessageBox.Show("Changing highlit text is not available.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If e.Button = Windows.Forms.MouseButtons.Left Then
            dlgColour.Color = CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionColor
            dlgColour.ShowDialog()
            If Windows.Forms.DialogResult.Cancel = True Then
                Exit Sub
            End If
            If Windows.Forms.DialogResult.OK = True Then
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionBackColor = dlgColour.Color
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = True
                TabControl1.SelectedTab.ImageIndex = 1
            End If
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionBackColor = dlgColour.Color
            Exit Sub
        End If
        If e.Button = Windows.Forms.MouseButtons.Right Then
            If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
                dlgColour.ShowDialog()
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).BackColor = dlgColour.Color
                Exit Sub
            End If
        End If
    End Sub
    '////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    'Context menu

    Private Sub CutToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles CutToolStripMenuItem.Click
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Cut()
        End If
    End Sub

    Private Sub CopyToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles CopyToolStripMenuItem.Click
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Copy()
        End If
    End Sub

    Private Sub PasteToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles PasteToolStripMenuItem.Click
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Paste()
        End If
    End Sub

    Private Sub SelectAllToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SelectAllToolStripMenuItem.Click
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectAll()
        End If
    End Sub

    Private Sub DeleteToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles DeleteToolStripMenuItem.Click
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectedRtf = ""
        End If
    End Sub

    Private Sub ImageToolStripMenuItem1_Click(sender As Object, e As EventArgs) Handles ImageToolStripMenuItem1.Click
        ImageToolStripMenuItem_Click(Me, e)
    End Sub

    Private Sub DateAndTimeToolStripMenuItem1_Click(sender As Object, e As EventArgs) Handles DateAndTimeToolStripMenuItem1.Click
        DateAndTimeToolStripMenuItem_Click(Me, e)
    End Sub

    Private Sub btnCloseTab_MouseUp(sender As Object, e As MouseEventArgs) Handles btnCloseTab.MouseUp
        Try
            If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
                Dim Response As MsgBoxResult
                If lblTabs.Text = 0 Then
                    MessageBox.Show("All tabs are closed.", "JunkNet", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    Exit Sub
                End If
                If e.Button = Windows.Forms.MouseButtons.Left Then
                    If lblTabs.Text = 0 Then
                        MessageBox.Show("All tabs are closed.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
                        Exit Sub
                    End If
                    TabControl1.SelectedTab.Dispose()
                    lblTabs.Text = lblTabs.Text - 1
                    inttabs = inttabs - 1
                    If lblTabs.Text = 0 Then
                        Me.Text = "JunkPad II - Empty"
                        comFont.Enabled = False
                        comFontSize.Enabled = False
                        pnlDisplay.Visible = False
                    End If
                    Exit Sub
                End If
                If e.Button = Windows.Forms.MouseButtons.Right Then
                    Try
                        If lblTabs.Text = 1 Then
                            Response = MsgBox("Are you sure you want to close the only tab?", MsgBoxStyle.Exclamation + MsgBoxStyle.YesNo, "JunkPad II")
                        Else
                            Response = MsgBox("Are you sure you want to close " + lblTabs.Text + " tabs?", MsgBoxStyle.Exclamation + MsgBoxStyle.YesNo, "JunkPad II")
                        End If
                        If Response = MsgBoxResult.No Then
                            Exit Sub
                        End If
                        If Response = MsgBoxResult.Yes Then
                            For i As Int32 = 0 To TabControl1.TabCount - 1
                                TabControl1.SelectedTab.Dispose()
                            Next
                            inttabs = 0
                            lblTabs.Text = 0
                            Me.Text = "JunkPad II - Empty"
                            comFont.Enabled = False
                            comFontSize.Enabled = False
                            pnlDisplay.Visible = False
                        End If
                    Catch Ex As System.OutOfMemoryException
                        MessageBox.Show("Not enough memory to process this item.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Catch Ex As Exception
                    End Try
                End If
                Exit Sub
            End If
            If e.Button = Windows.Forms.MouseButtons.Left Then
                Dim Response As MsgBoxResult
                If lblTabs.Text = 0 Then
                    MessageBox.Show("All tabs are closed.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    Exit Sub
                End If
                    If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
                        If CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = True Then
                            Response = MsgBox("Save changes to " + TabControl1.SelectedTab.Text + " ?", _
                                              MsgBoxStyle.Exclamation + MsgBoxStyle.YesNoCancel, _
                                              "JunkPad")
                            If Response = MsgBoxResult.No Then
                                TabControl1.SelectedTab.Dispose()
                                lblTabs.Text = lblTabs.Text - 1
                                If lblTabs.Text = 0 Then
                                    Me.Text = "JunkPad II - Empty"
                                    comFont.Enabled = False
                                    comFontSize.Enabled = False
                                    pnlDisplay.Visible = False
                                End If
                                Exit Sub
                            End If
                            If Response = MsgBoxResult.Cancel Then
                                Exit Sub
                            End If
                            If Response = MsgBoxResult.Yes Then
                                frmSave.Show()
                                TabControl1.SelectedTab.Dispose()
                                frmSave.Hide()
                                lblTabs.Text = lblTabs.Text - 1
                                Me.Text = "JunkPad II - " + TabControl1.SelectedTab.Text
                            End If
                            Exit Sub
                        End If
                        TabControl1.TabPages.Remove(TabControl1.SelectedTab)
                        lblTabs.Text = lblTabs.Text - 1
                        If lblTabs.Text = 0 Then
                            Me.Text = "JunkPad II - Empty"
                            comFont.Enabled = False
                            comFontSize.Enabled = False
                            pnlDisplay.Visible = False
                        End If
                    Else
                        TabControl1.SelectedTab.Dispose()
                        lblTabs.Text = lblTabs.Text - 1
                        Dim path As String = System.Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments)
                        Dim FILE_NAME As String = path & "\preview.html"
                        If System.IO.File.Exists(FILE_NAME) Then
                            System.IO.File.Delete(FILE_NAME)
                        End If
                        If lblTabs.Text = 0 Then
                            Me.Text = "JunkPad II - Empty"
                            comFont.Enabled = False
                            comFontSize.Enabled = False
                            pnlDisplay.Visible = False
                        End If
                    End If
                    Exit Sub
            End If
            If e.Button = Windows.Forms.MouseButtons.Right Then
                If lblTabs.Text = 0 Then
                    MessageBox.Show("All tabs are closed.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    Exit Sub
                End If
                Dim Response As MsgBoxResult
                Try
                    If lblTabs.Text = 1 Then
                        Response = MsgBox("Are you sure you want to close the only tab?", MsgBoxStyle.Exclamation + MsgBoxStyle.YesNo, "JunkPad II")
                    Else
                        Response = MsgBox("Are you sure you want to close " + lblTabs.Text + " tabs?", MsgBoxStyle.Exclamation + MsgBoxStyle.YesNo, "JunkPad II")
                    End If
                    If Response = MsgBoxResult.No Then
                        Exit Sub
                    End If
                    If Response = MsgBoxResult.Yes Then
                        For i As Int32 = 0 To TabControl1.TabCount - 1
                            TabControl1.SelectedTab.Dispose()
                        Next
                    End If
                Catch Ex As System.OutOfMemoryException
                    MessageBox.Show("Not enough memory to process this item.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Catch Ex As Exception
                End Try
                Me.Text = "JunkPad II - Empty"
                lblTabs.Text = 0
                lblCharCount.Text = 0
                lblWords.Text = 0
            End If
        Catch ex As Exception
        End Try
    End Sub

    Private Sub AppendTextToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles AppendTextToolStripMenuItem.Click
        btnAppendText_Click(Me, e)
    End Sub

    Private Sub AssociateWithDILDFilesToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles AssociateWithDILDFilesToolStripMenuItem.Click
        Try
            My.Computer.Registry.ClassesRoot.CreateSubKey(".dild") _
                .SetValue("", "JunkPad2", Microsoft.Win32.RegistryValueKind.String)
            My.Computer.Registry.ClassesRoot.CreateSubKey("JunkPad2\shell\open\command") _
                .SetValue("", Application.ExecutablePath & " ""%l"" ", Microsoft.Win32.RegistryValueKind.String)
            MsgBox("This program has been associated with the .dild extension. You may now open a .dild file from Windows Explorer.")
        Catch ex As UnauthorizedAccessException
            MessageBox.Show("You need to run JunkPad II as an administrator to do this." + Environment.NewLine + "If, for some reason you can't run it as an administrator, right-click on a .dild file, click 'Open with' and then select default program. Then, find where you ran this from and select this program." + Environment.NewLine + "DO NOT MOVE JUNKPAD AFTER YOU'VE DONE THIS!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub

    Private Sub lblTabs_Click(sender As Object, e As EventArgs) Handles lblTabs.Click
        MessageBox.Show("Number of text tabs: " + lblTabs.Text + Environment.NewLine + "Number of Internet tabs: " + inttabs.ToString + Environment.NewLine + "Maximum number of tabs (any): 256", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
    End Sub
    Private Sub btnNew_MouseUp(sender As Object, e As MouseEventArgs) Handles btnNew.MouseUp
        If lblTabs.Text = 256 Then
            MessageBox.Show("You have reached the maximux allowed tabs that can be created.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Hand)
            Exit Sub
        End If
        If lblTabs.Text = 0 Then
            addtab()
            Exit Sub
        End If
        If e.Button = Windows.Forms.MouseButtons.Left Then
            addtab()
        End If
        If e.Button = Windows.Forms.MouseButtons.Right Then
            INTaddtab()
        End If
    End Sub
    'END TEXT EDITOR CLASS - REMOVE THE BELOW IF YOU DON'T WANT THE BUILT-IN WEB BROWSER!

    '///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    '///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    '///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    'Internet related functions, do not touch for text editing! ////////////////////////////////////////////////////////////////////////////////////////
    Private Sub StartInternetToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles StartInternetToolStripMenuItem.Click
        comFont.Enabled = False
        comFontSize.Enabled = False
        btnSource.Visible = True
        INTaddtab()
    End Sub

    Private Sub INTaddtab()
        comFont.Enabled = False
        comFontSize.Enabled = False
        btnSource.Visible = True
        Dim myTabPage As New TabPage()
        Dim theweb As New WebBrowser()
        AddHandler theweb.DocumentCompleted, New WebBrowserDocumentCompletedEventHandler(AddressOf web_Loaded)
        AddHandler theweb.Navigated, New WebBrowserNavigatedEventHandler(AddressOf web_Navigated)
        AddHandler theweb.Navigating, New WebBrowserNavigatingEventHandler(AddressOf web_Navigating)
        myTabPage.Text = "Loading..."
        txtURL.Text = ""
        TabControl1.TabPages.Add(myTabPage)
        TabControl1.SelectTab(myTabPage)
        theweb.GoHome()
        theweb.ScriptErrorsSuppressed = True
        theweb.Parent = myTabPage
        theweb.Visible = True
        theweb.Dock = DockStyle.Fill
        TabControl1.SelectedTab.ImageIndex = 7
        lblTabs.Text = lblTabs.Text + 1
        inttabs = inttabs + 1
        pnlDisplay.Visible = True
    End Sub

    Private Sub INTdupetab()
        Try
            If lblTabs.Text = 0 Then
                Exit Sub
            End If
            Dim currenturl As String
            Dim myTabPage As New TabPage()
            Dim theweb As New WebBrowser()
            currenturl = CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).Url.ToString
            AddHandler theweb.DocumentCompleted, New WebBrowserDocumentCompletedEventHandler(AddressOf web_Loaded)
            AddHandler theweb.Navigated, New WebBrowserNavigatedEventHandler(AddressOf web_Navigated)
            AddHandler theweb.Navigating, New WebBrowserNavigatingEventHandler(AddressOf web_Navigating)
            myTabPage.Text = "Loading..."
            txtURL.Text = ""
            TabControl1.TabPages.Add(myTabPage)
            TabControl1.SelectTab(myTabPage)
            theweb.Navigate(currenturl)
            theweb.ScriptErrorsSuppressed = True
            theweb.Parent = myTabPage
            theweb.Visible = True
            theweb.Dock = DockStyle.Fill
            TabControl1.SelectedTab.ImageIndex = 7
            lblTabs.Text = lblTabs.Text + 1
            inttabs = inttabs + 1
        Catch ex As NullReferenceException
            MsgBox("The tab is loading. Please wait until it's done before you try again.", MsgBoxStyle.Exclamation + MsgBoxStyle.OkOnly, "JunkPad")
        Catch ex As InvalidCastException
        Catch ex As Exception
            MsgBox("An error occured while duplicating the tab.", MsgBoxStyle.Exclamation + MsgBoxStyle.OkOnly, "JunkPad")
        End Try
    End Sub

    Private Sub web_Loaded(sender As Object, e As EventArgs)
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
            TabControl1.SelectedTab.Text = CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).DocumentTitle
        End If
    End Sub

    Private Sub web_Navigating(sender As Object, e As EventArgs)
        Try
            If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
                TabControl1.SelectedTab.Text = "Loading..."
            End If
        Catch ex As Exception
            'ignore all errors
        End Try
    End Sub

    Private Sub web_Navigated(sender As Object, e As EventArgs)
        Try
            If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
                TabControl1.SelectedTab.Text = CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).DocumentTitle
                Me.Text = "JunkPad II - " + CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).DocumentTitle
                If CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).DocumentTitle = "" Then
                    TabControl1.SelectedTab.Text = "Loading..."
                    Me.Text = "JunkPad II - Loading..."
                End If
                txtURL.Text = CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).Url.ToString
            End If
        Catch ex As Exception
        End Try
    End Sub

    Private Sub btnNewTab_Click(sender As Object, e As EventArgs)
        INTaddtab()
    End Sub

    Private Sub loadhtml()
        Dim path As String
        Dim Response As MsgBoxResult
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            If lblTabs.Text = 256 Then
                MessageBox.Show("You have reached the maximux allowed tabs that can be created.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Hand)
                Exit Sub
            Else
                Dim open As New OpenFileDialog()
                path = open.InitialDirectory.ToString
                open.Filter = "HTML Files (*.html)|*.html|HTM Files (*.htm)|*.htm|All files (*.*)|*.*"
                If open.ShowDialog = Windows.Forms.DialogResult.OK Then
                    With open
                        Dim myTabPage As New TabPage()
                        Dim theweb As New WebBrowser()
                        AddHandler theweb.DocumentCompleted, New WebBrowserDocumentCompletedEventHandler(AddressOf web_Loaded)
                        AddHandler theweb.Navigated, New WebBrowserNavigatedEventHandler(AddressOf web_Navigated)
                        AddHandler theweb.Navigating, New WebBrowserNavigatingEventHandler(AddressOf web_Navigating)
                        txtURL.Text = ""
                        TabControl1.TabPages.Add(myTabPage)
                        TabControl1.SelectTab(myTabPage)
                        theweb.Navigate(open.FileName)
                        theweb.Parent = myTabPage
                        theweb.Visible = True
                        theweb.Dock = DockStyle.Fill
                        TabControl1.SelectedTab.ImageIndex = 7
                        lblTabs.Text = lblTabs.Text + 1
                        inttabs = inttabs + 1
                    End With
                    Exit Sub
                    open.Dispose()
                End If
            End If
        Else
            Response = MsgBox("Would you like to create a new tab to open the file?", MsgBoxStyle.Information + MsgBoxStyle.YesNo, "JunkNet")
            Try
                If Response = MsgBoxResult.No Then
                    Dim open1 As New OpenFileDialog()
                    open1.Filter = "HTML Files (*.html)|*.html|HTM Files (*.htm)|*.htm|All files (*.*)|*.*"
                    path = open1.InitialDirectory.ToString
                    If open1.ShowDialog = Windows.Forms.DialogResult.OK Then
                        TabControl1.SelectedTab.Text = open1.SafeFileName
                        Me.Text = "JunkPad II -" + TabControl1.SelectedTab.Text
                        CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).Navigate(open1.FileName)
                    End If
                    open1.Dispose()
                    Exit Sub
                ElseIf Response = MsgBoxResult.Yes Then
                    If lblTabs.Text = 256 Then
                        MessageBox.Show("You have reached the maximux allowed tabs that can be created.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Hand)
                        Exit Sub
                    Else
                        Dim open As New OpenFileDialog()
                        path = open.InitialDirectory.ToString
                        open.Filter = "HTML Files (*.html)|*.html|HTM Files (*.htm)|*.htm|All files (*.*)|*.*"
                        If open.ShowDialog = Windows.Forms.DialogResult.OK Then
                            With open
                                Dim myTabPage As New TabPage()
                                Dim theweb As New WebBrowser()
                                AddHandler theweb.DocumentCompleted, New WebBrowserDocumentCompletedEventHandler(AddressOf web_Loaded)
                                AddHandler theweb.Navigated, New WebBrowserNavigatedEventHandler(AddressOf web_Navigated)
                                AddHandler theweb.Navigating, New WebBrowserNavigatingEventHandler(AddressOf web_Navigating)
                                txtURL.Text = ""
                                TabControl1.TabPages.Add(myTabPage)
                                TabControl1.SelectTab(myTabPage)
                                theweb.Navigate(open.FileName)
                                theweb.ScriptErrorsSuppressed = True
                                theweb.Parent = myTabPage
                                theweb.Visible = True
                                theweb.Dock = DockStyle.Fill
                                TabControl1.SelectedTab.ImageIndex = 2
                                lblTabs.Text = lblTabs.Text + 1
                            End With
                            Exit Sub
                            open.Dispose()
                        End If
                    End If
                End If
            Catch ex As Exception
            End Try
        End If
    End Sub

    Private Sub btnGo_Click(sender As Object, e As EventArgs) Handles btnGo.Click
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
            If lblTabs.Text = 0 Then
                Exit Sub
            End If
            CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).Navigate(txtURL.Text)
        End If
    End Sub

    Private Sub btnRefresh_Click(sender As Object, e As EventArgs) Handles btnRefresh.Click
        If lblTabs.Text = 0 Then
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
            CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).Refresh()
        End If
    End Sub

    Private Sub btnStop_Click(sender As Object, e As EventArgs) Handles btnStop.Click
        If lblTabs.Text = 0 Then
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
            CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).Stop()
        End If
    End Sub

    Private Sub btnDupe_Click(sender As Object, e As EventArgs)
        If lblTabs.Text = 0 Then
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
            INTdupetab()
        End If
    End Sub

    Private Sub btnBack_Click(sender As Object, e As EventArgs) Handles btnBack.Click
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
            CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).Navigate(txtURL.Text)
        End If
    End Sub

    Private Sub btnHome_Click(sender As Object, e As EventArgs) Handles btnHome.Click
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
            CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).GoHome()
        End If
    End Sub

    Private Sub IgnoreScriptErrorsToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles IgnoreScriptErrorsToolStripMenuItem.Click
        If IgnoreScriptErrorsToolStripMenuItem.Checked = True Then
            CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).ScriptErrorsSuppressed = True
        Else
            CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).ScriptErrorsSuppressed = False
        End If
    End Sub

    Private Sub InternetOptionsToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles InternetOptionsToolStripMenuItem.Click
        Call Shell("RunDLL32.exe  Shell32.dll Control_RunDLL InetCpl.cpl", vbNormalFocus)
    End Sub

    Private Sub btnSource_Click(sender As Object, e As EventArgs) Handles btnSource.Click
        lblStatus.Visible = True
        If lblStatus.Visible = True Then
            getsource()
        End If
    End Sub

    Private Sub getsource()
        Try
            Dim webname As String = CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).DocumentTitle
            Dim sourceString As String = New System.Net.WebClient().DownloadString(txtURL.Text)
            addtab()
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text = sourceString
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = True
            TabControl1.SelectedTab.ImageIndex = 1
            TabControl1.SelectedTab.Text = webname + " (exported)"
            countwords()
            lblStatus.Visible = False
        Catch ex As Exception
            lblStatus.Visible = False
            MsgBox("The tab is loading. Please wait until it's done before you try again.", MsgBoxStyle.Exclamation + MsgBoxStyle.OkOnly, "JunkPad II")
        End Try
    End Sub

    Private Sub btnSearch_Click(sender As Object, e As EventArgs) Handles btnSearch.Click
        CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).GoSearch()
    End Sub

    Private Sub NewToolStripMenuItem_Click_1(sender As Object, e As EventArgs) Handles NewToolStripMenuItem.Click
        addtab()
    End Sub
End Class
