﻿Public Class frmMain

    Private Sub frmMain_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim richtext As New RichTextBox
        Dim edittab As New TabPage
        edittab.Controls.Add(richtext)
        richtext.Dock = DockStyle.Fill
        TabControl1.TabPages.Add(edittab)
        TabControl1.SelectTab(edittab)
        TabControl1.SelectedTab.Text = "unnamed (RTF)"
        lblTabs.Text = lblTabs.Text + 1
        lblTabType.Text = "Rich Text"
        Me.Text = "JunkPad II - " + TabControl1.SelectedTab.Text
    End Sub

    Private Sub NewRTFTabToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles NewRTFTabToolStripMenuItem.Click
        If lblTabs.Text = 384 Then
            MessageBox.Show("You have reached the maximux allowed tabs that can be created.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Hand)
            Exit Sub
        End If
        btnImage.Enabled = True
        btnImage.ToolTipText = "Insert an image into your document"
        btnColour.Enabled = True
        btnColour.ToolTipText = "Change the Font Colour"
        btnFont.Enabled = True
        btnFont.ToolTipText = "Change the font face, size and format."
        Dim richtext As New RichTextBox
        Dim edittab As New TabPage
        edittab.Controls.Add(richtext)
        richtext.Dock = DockStyle.Fill
        TabControl1.TabPages.Add(edittab)
        TabControl1.SelectTab(edittab)
        TabControl1.SelectedTab.Text = "unnamed (RTF)"
        lblTabs.Text = lblTabs.Text + 1
        lblTabType.Text = "Rich Text"
        Me.Text = "JunkPad II - " + TabControl1.SelectedTab.Text
    End Sub

    Private Sub NewStandardTextTabToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles NewStandardTextTabToolStripMenuItem.Click
        If lblTabs.Text = 384 Then
            MessageBox.Show("You have reached the maximux allowed tabs that can be created.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Hand)
            Exit Sub
        End If
        btnImage.Enabled = False
        btnImage.ToolTipText = "Images can't be inserted into plain text fields, because they can't be saved in this type."
        btnColour.Enabled = False
        btnColour.ToolTipText = "Font colour is not supported by this type."
        btnFont.Enabled = False
        btnFont.ToolTipText = "Changing the font format is not supported by this type."
        Dim richtext As New TextBox
        Dim edittab As New TabPage
        edittab.Controls.Add(richtext)
        richtext.Dock = DockStyle.Fill
        TabControl1.TabPages.Add(edittab)
        TabControl1.SelectTab(edittab)
        TabControl1.SelectedTab.Text = "unnamed (TXT)"
        lblTabs.Text = lblTabs.Text + 1
        CType(TabControl1.SelectedTab.Controls.Item(0), TextBox).Multiline = True
        Me.Text = "JunkPad II - " + TabControl1.SelectedTab.Text
        lblTabType.Text = "Plain Text"
    End Sub

    Private Sub btnRename_Click(sender As Object, e As EventArgs) Handles btnRename.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("QuickTabs menu is not available when all tabs are closed.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If lblTabs.Text >= 0 Then
            frmQuickTabs.ShowDialog()
        End If
    End Sub

    Private Sub btnCloseTab_Click(sender As Object, e As EventArgs) Handles btnCloseTab.Click
        Dim Response As MsgBoxResult
        If lblTabs.Text = 0 Then
            MessageBox.Show("All tabs are closed.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is TextBox Then
            If CType(TabControl1.SelectedTab.Controls.Item(0), TextBox).Modified = True Then
                Response = MsgBox("Save changes to " + TabControl1.SelectedTab.Text + " ?", _
                                  MsgBoxStyle.Exclamation + MsgBoxStyle.YesNo, _
                                  "JunkPad")
                If Response = MsgBoxResult.No Then
                    TabControl1.TabPages.Remove(TabControl1.SelectedTab)
                    Exit Sub
                End If
                If Response = MsgBoxResult.Yes Then
                    Dim Save As New SaveFileDialog()
                    Dim myStreamWriter As System.IO.StreamWriter
                    Save.Filter = "Plain Text Files (*.txt)|*.txt|Batch Files (*.bat)|*.bat|DOC Files (*.doc)|*.doc|HTML Files (*.html)|*.html|All files (*.*)|*.*"
                    Save.CheckPathExists = True
                    Save.ShowDialog(Me)
                    Try
                        myStreamWriter = System.IO.File.CreateText(Save.FileName)
                        myStreamWriter.Write(CType(TabControl1.SelectedTab.Controls.Item(0), TextBox).Text)
                        myStreamWriter.Flush()
                        TabControl1.SelectedTab.Text = Save.FileName
                    Catch ex As Exception
                        ' Do nothing on Exception
                    End Try
                    TabControl1.TabPages.Remove(TabControl1.SelectedTab)
                End If
            End If
            If CType(TabControl1.SelectedTab.Controls.Item(0), TextBox).Modified = False Then
                TabControl1.TabPages.Remove(TabControl1.SelectedTab)
            End If
            lblTabs.Text = lblTabs.Text - 1
            If lblTabs.Text = 0 Then
                Me.Text = "JunkPad II - Empty"
                lblTabType.Text = "Null"
            End If
            Exit Sub
        End If

        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            If CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = True Then
                Response = MsgBox("Save changes to " + TabControl1.SelectedTab.Text + " ?", _
                                  MsgBoxStyle.Exclamation + MsgBoxStyle.YesNo, _
                                  "JunkPad")
                If Response = MsgBoxResult.No Then
                    TabControl1.TabPages.Remove(TabControl1.SelectedTab)
                    lblTabs.Text = lblTabs.Text - 1
                    If lblTabs.Text = 0 Then
                        Me.Text = "JunkPad II - Empty"
                        lblTabType.Text = "Null"
                    End If
                    Exit Sub
                End If
                If Response = MsgBoxResult.Yes Then
                    ' Create a SaveFileDialog to request a path and file name to save to. 
                    Dim saveFile1 As New SaveFileDialog()

                    ' Initialize the SaveFileDialog to specify the RTF extention for the file.
                    saveFile1.DefaultExt = "*.dild"
                    saveFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf|All files (*.*)|*.*"

                    ' Determine whether the user selected a file name from the saveFileDialog. 
                    If (saveFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                        And (saveFile1.FileName.Length > 0) Then

                        ' Save the contents of the RichTextBox into the file.
                        CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SaveFile(saveFile1.FileName)
                    End If
                    TabControl1.TabPages.Remove(TabControl1.SelectedTab)
                    lblTabs.Text = lblTabs.Text - 1
                End If
            End If

            If CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False Then
                TabControl1.TabPages.Remove(TabControl1.SelectedTab)
                lblTabs.Text = lblTabs.Text - 1
            End If
            If lblTabs.Text = 0 Then
                Me.Text = "JunkPad II - Empty"
                lblTabType.Text = "Null"
            End If
            Exit Sub
        End If
        If lblTabType.Text = "HTML File" Then
            TabControl1.TabPages.Remove(TabControl1.SelectedTab)
            lblTabs.Text = lblTabs.Text - 1
        End If
        If lblTabs.Text = 0 Then
            Me.Text = "JunkPad II - Empty"
            lblTabType.Text = "Null"
        End If
    End Sub

    Private Sub TabControl1_DoubleClick(sender As Object, e As EventArgs) Handles TabControl1.DoubleClick
        Try
            CType(frmQuickTabs.Controls.Item("txtBoxName"), TextBox).Text = TabControl1.SelectedTab.Text
            frmQuickTabs.ShowDialog()
            TabControl1.SelectedTab.Text = CType(frmQuickTabs.Controls.Item("txtBoxName"), TextBox).Text
            Me.Text = "JunkPad II - " + TabControl1.SelectedTab.Text
        Catch Ex As Exception
            MessageBox.Show("No tabs to rename.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try
    End Sub

    Private Sub TabControl1_Selected(sender As Object, e As TabControlEventArgs) Handles TabControl1.Selected
        Try
            If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is TextBox Then
                btnBack.Visible = False
                btnForward.Visible = False
                btnRefresh.Visible = False
                btnStop.Visible = False
                btnWebHome.Visible = False
                txtboxurl.Visible = False
                btnGo.Visible = False
                lblTabType.Text = "Plain Text"
                Me.Text = "JunkPad II - " + TabControl1.SelectedTab.Text
                btnImage.Enabled = False
                btnImage.ToolTipText = "Images can't be inserted into plain text fields, because they can't be saved in this type."
                btnColour.Enabled = False
                btnColour.ToolTipText = "Font colour is not supported by this type."
                btnFont.Enabled = False
                btnFont.ToolTipText = "Changing the font format is not supported by this type."
            End If

            If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
                btnBack.Visible = False
                btnForward.Visible = False
                btnRefresh.Visible = False
                btnStop.Visible = False
                btnWebHome.Visible = False
                txtboxurl.Visible = False
                btnGo.Visible = False
                lblTabType.Text = "Rich Text"
                Me.Text = "JunkPad II - " + TabControl1.SelectedTab.Text
                btnImage.Enabled = True
                btnImage.ToolTipText = "Insert an image into your document"
                btnColour.Enabled = True
                btnColour.ToolTipText = "Change the Font Colour"
                btnFont.Enabled = True
                btnFont.ToolTipText = "Change the font face, size and format."
                Exit Sub
            End If
            If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is WebBrowser Then
                btnBack.Visible = True
                btnForward.Visible = True
                btnRefresh.Visible = True
                btnStop.Visible = True
                btnWebHome.Visible = True
                txtboxurl.Visible = True
                btnGo.Visible = True
                lblTabType.Text = "HTML File"
                btnImage.Enabled = False
                btnImage.ToolTipText = "Images can't be inserted into webbrowsers."
                btnColour.Enabled = False
                btnColour.ToolTipText = "Font colour can't be change inside webbrowsers."
                btnFont.Enabled = False
                btnFont.ToolTipText = "Font can't be change inside webbrowsers."
                Me.Text = "JunkPad II - " + TabControl1.SelectedTab.Text
            End If
        Catch ex As Exception
            'ignores the first chance exception 'System.NullReferenceException'
        End Try
    End Sub

    Private Sub SaveToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SaveAsToolStripMenuItem.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs open. Saving cancelled!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is TextBox Then
            Dim Save As New SaveFileDialog()
            Dim myStreamWriter As System.IO.StreamWriter
            Save.Filter = "Text Files (*.txt)|*.txt|Batch Files (*.bat)|*.bat|HTML Files (*.html; *.htm)|*.html; *.htm|PHP Files (*.php)|*.php|INF Files (*.inf)|*.inf|INI Files (*.ini)|*.ini|CFG Files (*.cfg)|*.cfg|COM Files (*.com)|*.com|Visual Basic files (*.vb)|*.vb|All files (*.*)|*.*"
            Save.CheckPathExists = True
            Save.ShowDialog(Me)
            'Try
            myStreamWriter = System.IO.File.CreateText(Save.FileName)
            myStreamWriter.Write(CType(TabControl1.SelectedTab.Controls.Item(0), TextBox).Text)
            myStreamWriter.Flush()
            TabControl1.SelectedTab.Text = Save.FileName
            'Catch ex As Exception
            'MessageBox.Show("Saving file failed, or saving cancelled!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
            'End Try
            Exit Sub
        End If

        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            Dim saveFile1 As New SaveFileDialog()
            ' Initialize the SaveFileDialog to specify the RTF extention for the file.
            saveFile1.DefaultExt = "*.dild"
            saveFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf"

            ' Determine whether the user selected a file name from the saveFileDialog. 
            If (saveFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                And (saveFile1.FileName.Length > 0) Then

                ' Save the contents of the RichTextBox into the file.
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SaveFile(saveFile1.FileName)
                TabControl1.SelectedTab.Text = saveFile1.FileName
            End If
            Me.Text = "JunkPad II - " + TabControl1.SelectedTab.Text
            Exit Sub
        End If
    End Sub

    Private Sub btnCloseAllTabs_Click(sender As Object, e As EventArgs) Handles btnCloseAllTabs.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("All tabs are closed.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        Dim Response As MsgBoxResult
        Try
            Response = MsgBox("Save your changes in all tabs. Have you done this? If you haven't, you will lose any unsaved data!", _
                                  MsgBoxStyle.Exclamation + MsgBoxStyle.YesNo, _
                                  "JunkPad II")
            If Response = MsgBoxResult.No Then
                Exit Sub
            End If

            If Response = MsgBoxResult.Yes Then
                Dim name As TabPage = TabControl1.SelectedTab
                TabControl1.Controls.Remove(name)
                TabControl1.TabPages.Add(name)
                For i As Int32 = 0 To TabControl1.TabCount - 1
                    TabControl1.Controls.Remove(TabControl1.TabPages(0))
                Next
            End If
        Catch Ex As Exception

        End Try
        Me.Text = "JunkPad II - Empty"
        lblTabType.Text = "Null"
        lblTabs.Text = "0"
    End Sub


    Private Sub OpenToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles OpenToolStripMenuItem.Click
        If lblTabs.Text = 384 Then
            MessageBox.Show("You have reached the maximux allowed tabs that can be created.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Hand)
            Exit Sub
        End If
        frmOpen.Show()
    End Sub

    Private Sub btnImage_Click(sender As Object, e As EventArgs) Handles btnImage.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("You can't insert an image to an non-existant tab!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        Try
            Dim openFile1 As New OpenFileDialog()
            ' Initialize the OpenFileDialog to look for RTF files.
            openFile1.DefaultExt = "*.jpeg; *.jpg"
            openFile1.Filter = "Picture Files | *.jpg; *.png; *.gif; *.bmp |All files (*.*)|*.*"

            ' Determine whether the user selected a file from the OpenFileDialog. 
            If (openFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                And (openFile1.FileName.Length > 0) Then
                Dim img As Image = Image.FromFile(openFile1.FileName)
                Dim orgData = Clipboard.GetDataObject
                Clipboard.SetImage(img)
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Paste()

                Clipboard.SetDataObject(orgData)
            End If
        Catch ex As Exception
            MessageBox.Show("Invaild image.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Hand)
        End Try
    End Sub

    Private Sub btnFont_Click(sender As Object, e As EventArgs) Handles btnFont.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("You can't change font if no tabs exist!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        Try
            dlgFont.Font = CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont
            dlgFont.ShowDialog()
            If Windows.Forms.DialogResult.Cancel = True Then
                Exit Sub
            End If
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionFont = dlgFont.Font
        Catch ex As Exception
            MessageBox.Show("I only suppport TrueType fonts! Sorry about that. (the one you've selected isn't a true type one).", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Hand)
        End Try
    End Sub

    Private Sub btnColour_Click(sender As Object, e As EventArgs) Handles btnColour.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("You can't change the font colour in an non-existant tab!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        dlgColour.Color = CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionColor
        dlgColour.ShowDialog()
        If Windows.Forms.DialogResult.Cancel Then
            Exit Sub
        End If
        CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionColor = dlgColour.Color
    End Sub

    Private Sub btnUndo_Click(sender As Object, e As EventArgs) Handles btnUndo.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to Undo in.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is TextBox Then
            CType(TabControl1.SelectedTab.Controls.Item(0), TextBox).Undo()
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Undo()
            Exit Sub
        End If
    End Sub

    Private Sub btnRedo_Click(sender As Object, e As EventArgs) Handles btnRedo.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to Redo in.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Redo()
            Exit Sub
        End If
    End Sub

    Private Sub btnCloneTab_Click(sender As Object, e As EventArgs) Handles btnCloneTab.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("You can't duplicate an non-existant tab!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            Try
                Clipboard.SetText(CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text)
                Dim richtext As New RichTextBox
                Dim edittab As New TabPage
                edittab.Controls.Add(richtext)
                richtext.Dock = DockStyle.Fill
                TabControl1.TabPages.Add(edittab)
                TabControl1.SelectTab(edittab)
                TabControl1.SelectedTab.Text = "Cloned tab (RTF)"
                CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Paste()
                lblTabs.Text = lblTabs.Text + 1
                Me.Text = "JunkPad II - " + TabControl1.SelectedTab.Text
            Catch ex As Exception
                MessageBox.Show("Can't duplicate an non-existant tab, or one with no text in it.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Try
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is TextBox Then
            Try
                Clipboard.SetText(CType(TabControl1.SelectedTab.Controls.Item(0), TextBox).Text)
                Dim richtext As New TextBox
                Dim edittab As New TabPage
                edittab.Controls.Add(richtext)
                richtext.Dock = DockStyle.Fill
                richtext.Multiline = True
                TabControl1.TabPages.Add(edittab)
                TabControl1.SelectTab(edittab)
                TabControl1.SelectedTab.Text = "Cloned tab (TXT)"
                CType(TabControl1.SelectedTab.Controls.Item(0), TextBox).Paste()
                lblTabs.Text = lblTabs.Text + 1
                Me.Text = "JunkPad II - " + TabControl1.SelectedTab.Text
            Catch ex As Exception
                MessageBox.Show("Can't duplicate an non-existant tab, or one with no text in it.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Try
            Exit Sub
        End If
    End Sub

    Private Sub btnAppendText_Click(sender As Object, e As EventArgs) Handles btnAppendText.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("You can't append text to an non-existant tab!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is TextBox Then
            Try
                Clipboard.SetText(CType(TabControl1.SelectedTab.Controls.Item(0), TextBox).Text)

                Dim Open As New OpenFileDialog()
                Dim myStreamReader As System.IO.StreamReader
                Open.Filter = "Text Files (*.txt)|*.txt|Batch Files (*.bat)|*.bat|HTML Files (*.html)|*.html|All files (*.*)|*.*"
                Open.CheckFileExists = True
                Open.ShowDialog(Me)
                Try
                    Open.OpenFile()
                    myStreamReader = System.IO.File.OpenText(Open.FileName)
                    CType(TabControl1.SelectedTab.Controls.Item(0), TextBox).Text = myStreamReader.ReadToEnd()
                    TabControl1.SelectedTab.Text = Open.SafeFileName
                    CType(TabControl1.SelectedTab.Controls.Item(0), TextBox).Paste()
                Catch ex As Exception
                End Try
            Catch ex As Exception
                MessageBox.Show("You can't have a blank tab and append text! (Use Open file for that!)", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Try
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            Try
                Clipboard.SetText(CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text())
                Dim openFile1 As New OpenFileDialog()
                openFile1.DefaultExt = "*.dild"
                openFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf"

                ' Determine whether the user selected a file from the OpenFileDialog. 
                If (openFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                    And (openFile1.FileName.Length > 0) Then
                    CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).LoadFile(openFile1.FileName)
                    CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Paste()
                End If
            Catch ex As Exception
                MessageBox.Show("You can't have a blank tab and append text! (Use Open file for that!)", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Try
        End If
    End Sub

    Private Sub CustomSetupToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles CustomSetupToolStripMenuItem.Click
        frmNewTab.ShowDialog()
    End Sub

    Private Sub lblTabs_TextChanged(sender As Object, e As EventArgs) Handles lblTabs.TextChanged
        If lblTabs.Text = 384 Then
            lblTabLimit.Visible = True
        End If
        If lblTabs.Text < 384 Then
            lblTabLimit.Visible = False
        End If
    End Sub

    Private Sub NewToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles NewToolStripMenuItem.Click
        frmNewTab.ShowDialog()
    End Sub
#Region "Cut, Copy, Paste & Select All"
    Private Sub btnCut_Click(sender As Object, e As EventArgs) Handles btnCut.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to cut in.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Cut()
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is TextBox Then
            CType(TabControl1.SelectedTab.Controls.Item(0), TextBox).Cut()
            Exit Sub
        End If
    End Sub

    Private Sub btnPaste_Click(sender As Object, e As EventArgs) Handles btnPaste.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to paste in.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Paste()
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is TextBox Then
            CType(TabControl1.SelectedTab.Controls.Item(0), TextBox).Paste()
            Exit Sub
        End If
    End Sub

    Private Sub btnCopy_Click(sender As Object, e As EventArgs) Handles btnCopy.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to copy in.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Copy()
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is TextBox Then
            CType(TabControl1.SelectedTab.Controls.Item(0), TextBox).Copy()
            Exit Sub
        End If
    End Sub

    Private Sub btnSelectAll_Click(sender As Object, e As EventArgs) Handles btnSelectAll.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to Select All text in.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectAll()
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is TextBox Then
            CType(TabControl1.SelectedTab.Controls.Item(0), TextBox).SelectAll()
            Exit Sub
        End If
    End Sub
#End Region

    Private Sub btnTime_Click(sender As Object, e As EventArgs) Handles btnTime.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("You can't add the date to an non-existant tab!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectedText = DateAndTime.Now
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is TextBox Then
            CType(TabControl1.SelectedTab.Controls.Item(0), TextBox).SelectedText = DateAndTime.Now
            Exit Sub
        End If
    End Sub

    Private Sub GettingStartedToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles GettingStartedToolStripMenuItem.Click
        MessageBox.Show("Create a new tab and then type away!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
    End Sub

    Private Sub ChangeWindowColourToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ChangeWindowColourToolStripMenuItem.Click
        dlgColour.ShowDialog()
        Me.BackColor = dlgColour.Color
        ToolStrip1.BackColor = dlgColour.Color
        ToolStrip2.BackColor = dlgColour.Color
        MenuStrip1.BackColor = dlgColour.Color
        StatusStrip1.BackColor = dlgColour.Color
    End Sub

    Private Sub ResetWindowColourToDefaultToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ResetWindowColourToDefaultToolStripMenuItem.Click
        Me.BackColor = DefaultBackColor
        ToolStrip1.BackColor = DefaultBackColor
        ToolStrip2.BackColor = DefaultBackColor
        MenuStrip1.BackColor = DefaultBackColor
        StatusStrip1.BackColor = DefaultBackColor
    End Sub

    Private Sub ChangeTextColourwindowToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ChangeTextColourwindowToolStripMenuItem.Click
        dlgColour.ShowDialog()
        lblTab.ForeColor = dlgColour.Color
        lblTabs.ForeColor = dlgColour.Color
        lblTabsa.ForeColor = dlgColour.Color
        lblTabType.ForeColor = dlgColour.Color
        MenuStrip1.ForeColor = dlgColour.Color
    End Sub

    Private Sub ChangeTextfieldBackgroundToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ChangeTextfieldBackgroundToolStripMenuItem.Click
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            dlgColour.ShowDialog()
            CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).BackColor = dlgColour.Color
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is TextBox Then
            dlgColour.ShowDialog()
            CType(TabControl1.SelectedTab.Controls.Item(0), TextBox).BackColor = dlgColour.Color
            Exit Sub
        End If
    End Sub

    Private Sub ExitToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ExitToolStripMenuItem.Click
        Dim Response As MsgBoxResult
        Response = MsgBox("Save your changes in all tabs. Have you done this? If you haven't, you will lose any unsaved data!", _
                              MsgBoxStyle.Exclamation + MsgBoxStyle.YesNo, _
                              "JunkPad II")
        If Response = MsgBoxResult.No Then
            Exit Sub
        End If

        If Response = MsgBoxResult.Yes Then
            End
        End If
    End Sub

    Private Sub HidePanelToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles HidePanelToolStripMenuItem.Click
        ToolStrip2.Visible = False
        ToolStrip1.Visible = False
        pnlTop.Height = 28
        HidePanelToolStripMenuItem.Enabled = False
        ShowPanelToolStripMenuItem.Enabled = True
    End Sub

    Private Sub ShowPanelToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ShowPanelToolStripMenuItem.Click
        ToolStrip2.Visible = True
        ToolStrip1.Visible = True
        pnlTop.Height = 78
        HidePanelToolStripMenuItem.Enabled = True
        ShowPanelToolStripMenuItem.Enabled = False
    End Sub

    Private Sub PreviewFileToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles PreviewFileToolStripMenuItem.Click
        If lblTabs.Text = 0 Then
            MessageBox.Show("No tabs to preview HTML content in.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
            MessageBox.Show("Only Plain Text fields can have HTML content.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If
        If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is TextBox Then
            Dim fileName1 As String = IO.Path.GetFullPath(".\preview.html")
            Using writer As New IO.StreamWriter(fileName1)
                'writer.Write("This is a demo using a StreamWriter object.")
                writer.Write(CType(TabControl1.SelectedTab.Controls.Item(0), TextBox).Text)
                writer.Close()
            End Using
            If lblTabs.Text = 384 Then
                MessageBox.Show("You have reached the maximux allowed tabs that can be created. Previewing HTML file cancelled!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Hand)
                Exit Sub
            End If
            Dim richtext As New WebBrowser
            Dim edittab As New TabPage
            edittab.Controls.Add(richtext)
            richtext.Dock = DockStyle.Fill
            TabControl1.TabPages.Add(edittab)
            TabControl1.SelectTab(edittab)
            TabControl1.SelectedTab.Text = "HTML File"
            lblTabs.Text = lblTabs.Text + 1
            CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).ScriptErrorsSuppressed = True
            CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).Navigate("file:///" & IO.Path.GetFullPath(".\preview.html"))
            Me.Text = "JunkPad II - " + TabControl1.SelectedTab.Text
            lblTabType.Text = "HTML File"
        End If
    End Sub

    Private Sub LoadHTMLFileToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles LoadHTMLFileToolStripMenuItem.Click
        Dim open As New OpenFileDialog()

        Dim path As String
        path = open.InitialDirectory.ToString
        open.Filter = "HTML Files (*.html)|*.html|HTM Files (*.htm)|*.htm"
        If open.ShowDialog = Windows.Forms.DialogResult.OK Then

            With open
                Dim richtext As New WebBrowser
                Dim edittab As New TabPage
                edittab.Controls.Add(richtext)
                richtext.Dock = DockStyle.Fill
                TabControl1.TabPages.Add(edittab)
                TabControl1.SelectTab(edittab)
                TabControl1.SelectedTab.Text = "HTML File"
                Me.Text = "JunkPad II - " + TabControl1.SelectedTab.Text
                lblTabs.Text = lblTabs.Text + 1
                lblTabType.Text = "HTML File"
                CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).ScriptErrorsSuppressed = True
                CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).Navigate(open.FileName)
                open.Dispose()

            End With
        End If
        Exit Sub
    End Sub

    Private Sub StartInternetToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles StartInternetToolStripMenuItem.Click
        btnBack.Visible = True
        btnForward.Visible = True
        btnRefresh.Visible = True
        btnStop.Visible = True
        btnWebHome.Visible = True
        txtboxurl.Visible = True
        btnGo.Visible = True
        Dim richtext As New WebBrowser
        Dim edittab As New TabPage
        edittab.Controls.Add(richtext)
        richtext.Dock = DockStyle.Fill
        TabControl1.TabPages.Add(edittab)
        TabControl1.SelectTab(edittab)
        TabControl1.SelectedTab.Text = "HTML File"
        Me.Text = "JunkPad II - " + TabControl1.SelectedTab.Text
        lblTabs.Text = lblTabs.Text + 1
        lblTabType.Text = "HTML File"
        CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).ScriptErrorsSuppressed = True
        CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).GoHome()
    End Sub

    Private Sub btnGo_Click(sender As Object, e As EventArgs) Handles btnGo.Click
        CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).Navigate(txtboxurl.Text)
    End Sub

    Private Sub btnBack_Click(sender As Object, e As EventArgs) Handles btnBack.Click
        CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).GoBack()
    End Sub

    Private Sub btnForward_Click(sender As Object, e As EventArgs) Handles btnForward.Click
        CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).GoForward()
    End Sub

    Private Sub btnRefresh_Click(sender As Object, e As EventArgs) Handles btnRefresh.Click
        CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).Refresh()
    End Sub

    Private Sub btnStop_Click(sender As Object, e As EventArgs) Handles btnStop.Click
        CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).Stop()
    End Sub

    Private Sub btnWebHome_Click(sender As Object, e As EventArgs) Handles btnWebHome.Click
        CType(TabControl1.SelectedTab.Controls.Item(0), WebBrowser).GoHome()
    End Sub

    Private Sub frmMain_KeyPress(sender As Object, e As KeyPressEventArgs) Handles Me.KeyPress
        Try
            If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is RichTextBox Then
                Dim str As String
                str = CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).TextLength
                str = str + 1
                lblCharCount.Text = "Characters: " + str
                Try
                    Dim i, l, words As Integer
                    str = CType(TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text
                    str = LTrim(str) 'removes leading blank spaces
                    str = RTrim(str) ' removes trailing blank spaces
                    l = str.Length
                    i = 0
                    words = 0
                    While (i < l)
                        If str(i) = " " Then
                            words = words + 1
                            i = i + 1
                            While str(i) = " " ' removes continuous blank spaces
                                i = i + 1
                            End While
                        Else
                            i = i + 1
                        End If

                    End While
                    words = words + 1 ' adds the last word
                    lblWords.Text = ("Words: " & words)
                Catch
                    MessageBox.Show("No tabs to count words in.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Information)
                End Try
                Exit Sub
            End If
            If TypeOf TabControl1.SelectedTab.Controls.Item(0) Is TextBox Then
                Dim str As String
                str = CType(TabControl1.SelectedTab.Controls.Item(0), TextBox).TextLength
                str = str + 1
                lblCharCount.Text = "Characters: " + str
                Try
                    Dim i, l, words As Integer
                    str = CType(TabControl1.SelectedTab.Controls.Item(0), TextBox).Text
                    str = LTrim(str) 'removes leading blank spaces
                    str = RTrim(str) ' removes trailing blank spaces
                    l = str.Length
                    i = 0
                    words = 0
                    While (i < l)
                        If str(i) = " " Then
                            words = words + 1
                            i = i + 1
                            While str(i) = " " ' removes continuous blank spaces
                                i = i + 1
                            End While
                        Else
                            i = i + 1
                        End If

                    End While
                    words = words + 1 ' adds the last word
                    lblWords.Text = ("Words: " & words)
                Catch ex As Exception
                End Try
            End If
        Catch ex As Exception
        End Try
        Exit Sub
    End Sub
End Class
